#include "stdafx.h"
#include "ASCII2NUM.h"
#include "ASCII2NUMDlg.h"
#include "variables.h"
#include "AppIni.h"
#include "ascii_str.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CAppIni g_ini ("ASCII2NUM.ini");


CASCII2NUMDlg::CASCII2NUMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CASCII2NUMDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CASCII2NUMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_NUMBER_SYSTEM, _comboNumSys);
	DDX_Control(pDX, IDC_STATIC_HOMEPAGE, _staticHomepage);
	DDX_Control(pDX, IDC_EDIT_TEXT, _editText);
	DDX_Control(pDX, IDC_EDIT_STRING, _editString);
}

BEGIN_MESSAGE_MAP(CASCII2NUMDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_EN_CHANGE(IDC_EDIT_TEXT, &CASCII2NUMDlg::OnEnChangeEditText)
	ON_CBN_SELCHANGE(IDC_COMBO_NUMBER_SYSTEM, &CASCII2NUMDlg::OnCbnSelchangeComboNumberSystem)
	ON_EN_CHANGE(IDC_EDIT_PREFIX, &CASCII2NUMDlg::OnEnChangeEditPrefix)
	ON_EN_CHANGE(IDC_EDIT_SUFFIX, &CASCII2NUMDlg::OnEnChangeEditSuffix)
	ON_EN_CHANGE(IDC_EDIT_DELIMITER, &CASCII2NUMDlg::OnEnChangeEditDelimiter)
	ON_BN_CLICKED(IDOK, &CASCII2NUMDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CASCII2NUMDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


BOOL CASCII2NUMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	_fontMessage.CreatePointFont(120,"Fixedsys");   
	GetDlgItem(IDC_EDIT_TEXT)->SetFont(&_fontMessage);
	GetDlgItem(IDC_EDIT_STRING)->SetFont(&_fontMessage);

	_staticHomepage.SetURL("http://blog.daum.net/pg365/275");
	_staticHomepage.SetToolTipText("Visit webpage for 'ASCII to Number Converter");
	_staticHomepage.SetLinkCursor(::LoadCursor(0, MAKEINTRESOURCE(IDC_HAND)));

	CheckDlgButton (IDC_CHECK_CLIPBOARD,    (g_ini.options & OPT_AUTO_COPY_CLIPBOARD) ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton (IDC_CHECK_AUTO_CONVERT, (g_ini.options & OPT_AUTO_CONVERT)        ? BST_CHECKED : BST_UNCHECKED);

	_comboNumSys.SetCurSel (g_ini.numsys);
	SetDlgItemText (IDC_EDIT_TEXT,			g_ini.text);
	SetDlgItemText (IDC_EDIT_PREFIX,		g_ini.prefix);
	SetDlgItemText (IDC_EDIT_SUFFIX,		g_ini.suffix);
	SetDlgItemText (IDC_EDIT_DELIMITER,		g_ini.delimiter);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CASCII2NUMDlg::OnPaint()
{
	if (IsIconic()) {
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CASCII2NUMDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

const char *binary_str (unsigned char num)
{
	static char buff[9];

	for (int i=0; i<8; i++) {
		buff[7-i] = ((num >> i) & 0x01) ? '1' : '0';
	}
	buff[8] = '\0';
	return buff;
}

void CASCII2NUMDlg::ConvertASCII2Hexa ()
{
	CString escseq;
	GetDlgItemText (IDC_EDIT_TEXT, escseq);

	char *str = new char [escseq.GetLength ()+1];
	int str_len = escseq2str ((LPCSTR)escseq, str, escseq.GetLength ());
	str[str_len] = '\0';

	int max_n = str_len*(strlen(g_ini.prefix) + strlen(g_ini.suffix) + strlen(g_ini.delimiter) + 8);

	int n = 0;
	char *hexa = new char [max_n + 1];

	for (int i=0; i<str_len; i++) {
		n += _snprintf (hexa + n, max_n - n, "%s", g_ini.prefix);
		switch (g_ini.numsys){
		case 0: n += _snprintf (hexa + n, max_n - n, "%s", binary_str((unsigned char)str[i])); break;  //binary
		case 1: n += _snprintf (hexa + n, max_n - n, "%o",   (int)(unsigned char)str[i]); break;  //octal
		case 2: n += _snprintf (hexa + n, max_n - n, "%u",   (int)(unsigned char)str[i]); break;  //decimal
		case 3: n += _snprintf (hexa + n, max_n - n, "%02X", (int)(unsigned char)str[i]); break;  //hexadecimal
		}

		n += _snprintf (hexa + n, max_n - n, "%s", g_ini.suffix);
		if (i+1 < str_len) n += _snprintf (hexa + n, max_n - n, "%s", g_ini.delimiter);
	}
	hexa[max_n] = '\0';

	SetDlgItemText (IDC_EDIT_STRING, hexa);

	if (IsDlgButtonChecked (IDC_CHECK_CLIPBOARD)) {
		// Copy hexadecimal string to options
		Copy2Clipboard (hexa);
	}

	delete [] hexa;
	delete [] str;
}

void CASCII2NUMDlg::Copy2Clipboard (const char *hexa)
{
	const size_t len = strlen(hexa) + 1;
	HGLOBAL hMem =  GlobalAlloc (GMEM_MOVEABLE, len);
	memcpy (GlobalLock(hMem), hexa, len);
	GlobalUnlock (hMem);

	OpenClipboard ();
	EmptyClipboard ();
	SetClipboardData (CF_TEXT, hMem);
	CloseClipboard ();

	//GlobalFree (hMem);
}

void CASCII2NUMDlg::OnEnChangeEditText()
{
	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		ConvertASCII2Hexa ();
	}
}

void CASCII2NUMDlg::OnCbnSelchangeComboNumberSystem()
{
	g_ini.numsys = _comboNumSys.GetCurSel ();

	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		ConvertASCII2Hexa ();
	}
}

void CASCII2NUMDlg::OnEnChangeEditPrefix()
{
	GetDlgItemText (IDC_EDIT_PREFIX,	g_ini.prefix, 16);
	g_ini.prefix[16] = 0;

	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		ConvertASCII2Hexa ();
	}
}

void CASCII2NUMDlg::OnEnChangeEditSuffix()
{
	GetDlgItemText (IDC_EDIT_SUFFIX,	g_ini.suffix, 16);
	g_ini.suffix[16] = 0;

	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		ConvertASCII2Hexa ();
	}
}

void CASCII2NUMDlg::OnEnChangeEditDelimiter()
{
	GetDlgItemText (IDC_EDIT_DELIMITER,	g_ini.delimiter, 16);
	g_ini.delimiter[16] = 0;

	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		ConvertASCII2Hexa ();
	}
}

void CASCII2NUMDlg::OnBnClickedOk()
{
	ConvertASCII2Hexa ();

	// OnOK();
}

void CASCII2NUMDlg::OnBnClickedCancel()
{
	g_ini.numsys    = _comboNumSys.GetCurSel ();

	GetDlgItemText (IDC_EDIT_TEXT,		g_ini.text, 256);
	g_ini.text[256] = 0;

	GetDlgItemText (IDC_EDIT_PREFIX,	g_ini.prefix, 16);
	g_ini.prefix[16] = 0;

	GetDlgItemText (IDC_EDIT_SUFFIX,	g_ini.suffix, 16);
	g_ini.suffix[16] = 0;

	GetDlgItemText (IDC_EDIT_DELIMITER,	g_ini.delimiter, 16);
	g_ini.delimiter[16] = 0;

	g_ini.options = 0;
	if (IsDlgButtonChecked (IDC_CHECK_CLIPBOARD) == BST_CHECKED) {
		g_ini.options |= OPT_AUTO_COPY_CLIPBOARD;
	}
	if (IsDlgButtonChecked (IDC_CHECK_AUTO_CONVERT) == BST_CHECKED) {
		g_ini.options |= OPT_AUTO_CONVERT;
	}

	OnCancel();
}
