#include "stdafx.h"
#include "variables.h"

const sVariableInfo _variables[] = {
	{   1, "_vid",		"_vendor_id",			VT_I32,	VA_RO  },
	{   2, "_pid",		"_product_id",			VT_I32,	VA_RO  },	
	{   3, "_swv",		"_software_version",	VT_F32,	VA_RO  },	
	{   4, "_hwv",		"_hardware_version",	VT_F32,	VA_RO  },	
	{   5, "_sst",		"_system_status",		VT_I32,	VA_RO  },	
	{   7, "_sco",		"_system_command",		VT_I16,	VA_WO  },	
	{   7, "_sco",		"_system_command",		VT_I16,	VA_WO  },	
	{   8, "_bv",		"_battery_voltage",		VT_F32,	VA_RO  },	
	{   9, "_bc",		"_battery_current",		VT_F32,	VA_RO  },	
													
	{  11, "_id",		"_device_id",			VT_I32,	VA_RW  },	
	{  12, "_cb",		"_can_br",				VT_I32,	VA_RW  },	
	{  13, "_sb",		"_serial_bps",			VT_I32,	VA_RW  },	
	{  13, "_sb",		"_serial_bps",			VT_I32,	VA_RW  },	
	{  14, "_sw",		"_serial_watchdog",		VT_I32,	VA_RW  },	
													
	{  16, "_ssr",		"_startup_script_run",	VT_I8,	VA_RW  },	
													 		
	{  21, "_cm",		"_control_mixing",		VT_I8,	VA_RW  },	
	{  22, "_cs",		"_center_safety",		VT_I8,	VA_RW  },	
	{  23, "_ms",		"_min_max_safety",		VT_I8,	VA_RW  },	
													 		
	{  31, "_ps",		"_pwm_switching",		VT_I8,	VA_RW  },	
	{  32, "_pf",		"_pwm_frequency",		VT_I8,	VA_RW  },	
													
	{  56, "_uv",		"_user_value",			VT_I32,	VA_RW  },	
	{  57, "_tv",		"_temp_value",			VT_I32,	VA_RW  },	
													
	{  60, "_ndi",		"_num_dis",				VT_I8,	VA_RO  },	
	{  61, "_die",		"_di_enable",			VT_I32,	VA_RW  },	
	{  62, "_dii",		"_di_invert",			VT_I32,	VA_RW  },	
	{  63, "_di",		"_di_all_values",		VT_I32,	VA_RO  },	
	{  65, "_ndo",		"_num_dos",				VT_I8,	VA_RO  },	
	{  66, "_doe",		"_do_enable",			VT_I32,	VA_RW  },	
	{  67, "_doi",		"_do_invert",			VT_I32,	VA_RW  },	
	{  68, "_do",		"_do_all_values",		VT_I32,	VA_RW  },	
	{  70, "_nai",		"_num_ais",				VT_I8,	VA_RO  },	
	{  71, "_aie",		"_ai_enable",			VT_I32,	VA_RW  },	
	{  72, "_aii",		"_ai_invert",			VT_I32,	VA_RW  },	
	{  75, "_npi",		"_num_pis",				VT_I8,	VA_RO  },	
	{  76, "_pie",		"_pi_enable",			VT_I32,	VA_RW  },	
	{  77, "_pii",		"_pi_invert",			VT_I32,	VA_RW  },	
															
	{  80, "_nm",		"_num_motors",			VT_I8,	VA_RO  },	
						 
	{  86, "_wr",		"_wheel_radius",		VT_F32,	VA_RW  },	
	{  87, "_al",		"_axle_length",			VT_F32,	VA_RW  },	
	{  88, "_gr",		"_gear_ratio",			VT_F32,	VA_RW  },	
													
	{ 101, "_co",		"_command",				VT_I16,	VA_WO  },	
	{ 102, "_s",		"_status",				VT_I32,	VA_RO  },	
	{ 103, "_f",		"_fault",				VT_I32,	VA_RO  },	
															
	{ 111, "_pc",		"_position_command",	VT_I32,	VA_RW  },	
	{ 112, "_vc",		"_velocity_command",	VT_F32,	VA_RW  },	
	{ 113, "_cc",		"_current_command",		VT_F32,	VA_RW  },	
	{ 114, "_vtc",		"_voltage_command",		VT_F32,	VA_RW  },	
															
	{ 121, "_tp",		"_temperature",			VT_F32,	VA_RO  },	
	{ 122, "_vt",		"_voltage",				VT_F32,	VA_RO  },	
	{ 123, "_c",		"_current",				VT_F32,	VA_RO  },	
	{ 124, "_v",		"_velocity",			VT_F32,	VA_RO  },	
	{ 125, "_p",		"_position",			VT_I32,	VA_RW  },	
	{ 126, "_h",		"_hall_count",			VT_I32,	VA_RW  },	
	{ 131, "_pt",		"_ai_potentiometer",	VT_F32,	VA_RO  },	
	{ 132, "_ta",		"_ai_tachometer",		VT_F32,	VA_RO  },	
															
	{ 141, "_np",		"_min_position",		VT_I32,	VA_RW  },	
	{ 142, "_xp",		"_max_position",		VT_I32,	VA_RW  },	
	{ 143, "_hp",		"_home_position",		VT_I32,	VA_RW  },	
	{ 144, "_ep",		"_encoder_ppr",			VT_I16,	VA_RW  },	
	{ 145, "_npp",		"_num_pole_pairs",		VT_I16,	VA_RW  },	
	{ 146, "_usl",		"_use_soft_limit",		VT_I8,	VA_RW  },	
															
	{ 151, "_xc",		"_max_current",			VT_F32,	VA_RW  },	
	{ 152, "_xvt",		"_max_voltage",			VT_F32,	VA_RW  },	
	{ 153, "_xv",		"_max_velocity",		VT_F32,	VA_RW  },	
	{ 154, "_ac",		"_acceleration",		VT_F32,	VA_RW  },	
	{ 155, "_dc",		"_deceleration",		VT_F32,	VA_RW  },	
															
	{ 161, "_ohl",		"_overheat_limit",		VT_F32,	VA_RW  },	
	{ 162, "_ocl",		"_overcurrent_limit",	VT_F32,	VA_RW  },	
	{ 163, "_ocd",		"_overcurrent_delay",	VT_I16,	VA_RW  },	
	{ 164, "_pcr",		"_peakcurrent_ratio",	VT_F32,	VA_RW  },	
	{ 165, "_ovl",		"_overvoltage_limit",	VT_F32,	VA_RW  },	
	{ 166, "_uvl",		"_undervoltage_limit",	VT_F32,	VA_RW  },	
	{ 167, "_sd",		"_stall_detection",		VT_I8,	VA_RW  },	
	{ 168, "_ved",		"_vel_error_detection",	VT_I8,	VA_RW  },	
	{ 169, "_ped",		"_pos_error_detection",	VT_I8,	VA_RW  },	
															
	{ 171, "_fs",		"_feedback_sensor",		VT_I8,	VA_RW  },	
	{ 172, "_pm",		"_profile_mode",		VT_I8,	VA_RW  },	
	{ 173, "_spo",		"_startup_power_on",	VT_I8,	VA_RW  },	
	{ 174, "_dir",		"_direction",			VT_I8,	VA_RW  },	
	{ 175, "_bod",		"_brake_on_delay",		VT_I16,	VA_RW  },	
	{ 176, "_hv",		"_high_voltage",		VT_I16,	VA_RW  },	
	{ 177, "_ht",		"_high_temperature",	VT_I16,	VA_RW  },	
															
	{ 181, "_cp",		"_cc_kp",				VT_F32,	VA_RW  },	
	{ 182, "_ci",		"_cc_ki",				VT_F32,	VA_RW  },	
	{ 185, "_cff",		"_cc_kff",				VT_F32,	VA_RW  },	
															
	{ 186, "_vp",		"_vc_kp",				VT_F32,	VA_RW  },	
	{ 187, "_vi",		"_vc_ki",				VT_F32,	VA_RW  },	
	{ 190, "_vs",		"_vc_ks",				VT_F32,	VA_RW  },	
															
	{ 191, "_pp",		"_pc_kp",				VT_F32,	VA_RW  },	
	{ 192, "_pi",		"_pc_ki",				VT_F32,	VA_RW  },	
	{ 193, "_pd",		"_pc_kd",				VT_F32,	VA_RW  },	
						 
	{ 201, "_div",		"_di_value",			VT_I8,	VA_RO  },	
	{ 202, "_dif",		"_di_function",			VT_I16,	VA_RW  },	
						 
	{ 211, "_dov",		"_do_value",			VT_I8,	VA_RW  },	
	{ 212, "_dof",		"_do_function",			VT_I16,	VA_RW  },	
						 
	{ 221, "_aiv",		"_ai_value",			VT_I32,	VA_RO  },	
	{ 222, "_aicv",		"_ai_converted_value",	VT_F32,	VA_RO  },	
	{ 223, "_ail",		"_ai_linearity",		VT_I8,	VA_RW  },	
	{ 224, "_aif",		"_ai_function",			VT_I16,	VA_RW  },	
	{ 225, "_ain",		"_ai_input_min",		VT_I32,	VA_RW  },	
	{ 226, "_aic",		"_ai_input_center",		VT_I32,	VA_RW  },	
	{ 227, "_aix",		"_ai_input_max",		VT_I32,	VA_RW  },	
	{ 228, "_aidb",		"_ai_input_deadband",	VT_I32,	VA_RW  },	
						 
	{ 231, "_piv",		"_pi_value",			VT_I32,	VA_RO  },	
	{ 232, "_picv",		"_pi_converted_value",	VT_F32,	VA_RO  },	
	{ 233, "_pit",		"_pi_capture_type",		VT_I8,	VA_RW  },	
	{ 234, "_pil",		"_pi_linearity",		VT_I8,	VA_RW  },	
	{ 235, "_pif",		"_pi_function",			VT_I16,	VA_RW  },	
	{ 236, "_pin",		"_pi_input_min",		VT_I32,	VA_RW  },	
	{ 237, "_pic",		"_pi_input_center",		VT_I32,	VA_RW  },	
	{ 238, "_pix",		"_pi_input_max",		VT_I32,	VA_RW  },	
	{ 239, "_pidb",		"_pi_input_deadband",	VT_I32,	VA_RW  },	
													
	{ 250, "_ss",		"_script_size",			VT_I32,	VA_WO  },	
	{ 251, "_sc",		"_script_code",			VT_I32,	VA_WO  },	
						 
	{ 252, "_sv",		"_script_variable",		VT_F32,	VA_RO  },	
};

const int _variables_num= sizeof(_variables)/sizeof(sVariableInfo);

const sVariableInfo *GetVariableInfo (int prefix)
{
	for (int i=0; i<_variables_num; i++){
		if (_variables[i].prefix == prefix) return &_variables[i];
	}
	return NULL;
}

int GetVariableOrder (int prefix)
{
	for (int i=0; i<_variables_num; i++){
		if (_variables[i].prefix == prefix) return i;
	}
	return -1;
}

